// source : https://stackoverflow.com/questions/68732160/make-a-div-bigger-and-wider-while-scrolling

function getSize(curbID: number, yValue: number): number{
    let offset = 2/5; // difference between each curve
    let stableLen = 0.1;
    let mainFunc = (-Math.abs(yValue - curbID*offset)+1+stableLen)/2 + Math.abs((-Math.abs(yValue - curbID*offset)+1+stableLen)/2);
    /* basically do that :
          /\
    _____/  \______
     */
    let secoFunc = (-Math.abs(yValue - curbID*offset)+stableLen)/2 + Math.abs((-Math.abs(yValue - curbID*offset)+stableLen)/2);
    /* basically do that :
    ______/\______
    so the difference do
           __
    ______/  \______
     */

    return mainFunc - secoFunc
}


function setupPage(){
    let elements = document.getElementsByClassName("container");
    for (let i = 0; i<elements.length; i++){
        elements[i].id = "card" + i;
    }
}


function changeWidth()
{
    // Variables
    let speedFactor = 1/10;
    let nb_div = document.getElementsByClassName("container").length;
    let offset = 3.5/speedFactor; // this is the number of false data-points added at the end. it doesn't work well when modifying speed_factor

    // Elements
    let timeLineElm = document.getElementById("timeline");
    let startTimeElm = document.getElementById("startTime");
    let spacer1 = document.getElementById("spacer1");
    let projetPerso = document.getElementById("projetPerso");


    // Positions
    let startTimeBoxSize = startTimeElm.getBoundingClientRect()
    let ymin = startTimeBoxSize.top + window.scrollY;
    let ymax = document.getElementById(`card${nb_div-1}`).getBoundingClientRect().bottom + window.scrollY;


    // get each maximum card size
    let cardSizes: number[] = []

    // fill the cardSizes array with original height of each card
    function calculateCardSizes(){
        timeLineElm.style.height = `${0.8*window.screen.height}px`;
        console.log("taille de la fenetre: " + window.screen.height)
        console.log("taille de la barre" + timeLineElm.style.height);
        cardSizes = []
        for (let i = 0; i<nb_div; i++){
            let cardElem = document.getElementById("card"+i);
            cardElem.style.transform = 'scale(1)';
            cardElem.style.display = ""
            cardElem.style.height = ""
            let cardSize = cardElem.getBoundingClientRect().bottom - cardElem.getBoundingClientRect().top;
            cardSizes.push(cardSize);
        }



    }

    calculateCardSizes()

    function scaleAllCards(scrollVal: number){
        console.log(timeLineElm.style.height);

        let shownCardsSizes = []
        for (let i = 0; i<nb_div; i++){
            let s = getSize(i, scrollVal*speedFactor);
            if (s>0.01)
                shownCardsSizes.push([cardSizes[i], s])
        }

        let c = timeLineElm.style.height.replace("px", "");

        // @ts-ignore
        let scaleOffset = (c - shownCardsSizes.reduce((x, y) => x+y[0]*y[1], 0)) /shownCardsSizes.map((x) => x[0]).reduce((x, y) => x+y);
        //x = c - sum(ai*si)/sum(ai)
        for (let i = 0; i<nb_div; i++){
            let cardElem = document.getElementById("card"+i);

            let s = getSize(i, scrollVal*speedFactor);
            cardElem.style.display = s<0.01 ? "none" : ""
            cardElem.style.transform = `scale(${s})`
            cardElem.style.transform = `scale(${s})`

            cardElem.style.height = `${cardSizes[i] * (s+Math.max(scaleOffset, 0))}px`
            if (window.matchMedia("(max-width: 1000px)").matches)
                cardElem.style.left = `${15*(2-s)}px` // 15px + the size missing to the circle

        }

    }

    scaleAllCards((timeLineElm.getBoundingClientRect().y - ymin) / (ymax - ymin) * nb_div);

    // action to take whenever we go above the timeline or under
    function all(){
        startTimeElm.style.position = "relative";
        timeLineElm.style.position = "relative";
        startTimeElm.style.top = ""
        timeLineElm.style.top = ""
        projetPerso.style.top = ""
        projetPerso.style.position = "relative";

    }


    // action to take whenever we go above the timeline
    function backToTop(){
        spacer1.style.height="0px";
        if (window.matchMedia("(max-width: 1000px)").matches)
            timeLineElm.style.left =  "23px" // TODO this 23 shouldn't be hardcoded
    }


    // action to take whenever we go under the timeline
    function under() {
        if(spacer1.style.height.replace("px", "") < "100"){
            spacer1.style.height = - spacer1.getBoundingClientRect().bottom + "px";
        }

    }


    // main function, called each time we scroll
    function changeWidthParam(){
        let scrollVal = (window.scrollY - ymin) / (ymax - ymin) * nb_div
        if (window.scrollY > ymin && scrollVal < nb_div + offset){
            if (timeLineElm.style.position !== "fixed"){ // apply once

                startTimeElm.style.position = "fixed"
                startTimeElm.style.right = "0%";
                startTimeElm.style.left = "0%";
                startTimeElm.style.top =  0 + "px";

                timeLineElm.style.position = "fixed";
                timeLineElm.style.left = "0%";
                if (window.matchMedia("(max-width: 1000px)").matches){
                    timeLineElm.style.left =  "31px"
                    console.log("Mobile Version")

                }
                    timeLineElm.style.top = startTimeElm.getBoundingClientRect().bottom + 20 + "px";

                projetPerso.style.position = "fixed";
                projetPerso.style.top = timeLineElm.getBoundingClientRect().bottom + 'px'
                projetPerso.style.right = "0%";
                projetPerso.style.left = "0%";

            }

            scaleAllCards(scrollVal);
        }
        else {
            all();
            if (scrollVal < 2){
                backToTop();
            }
            else {
                under();
            }

        }
    }

    function updateSize(){
        calculateCardSizes()
        changeWidthParam()
    }
    return {"main" : changeWidthParam, "updateSize" : updateSize};
}

window.addEventListener("load", function (){
    setupPage();
    let f = changeWidth();
    window.addEventListener('scroll', function()
    {
        requestAnimationFrame(f.main);
    }, false);
    addEventListener("resize", (event) => f.updateSize());

})




// source: https://stackoverflow.com/a/26837814
window.onbeforeunload = function () {
    window.scrollTo(0, 0);
}
